//+------------------------------------------------------------------+
//|                                Shinigami RSI Crossover EA v5.mq4 |
//|                                                     by Shinigami |
//|                                              Shini1984@gmail.com |
//+------------------------------------------------------------------+
#property copyright "Shinigami 2007-2010"
#property link      "shini1984@gmail.com"

extern int Takeprofit = 100;
extern int Stoploss = 100;
extern int RSI14_Value_Buy_Open  = 40;
extern int RSI14_Value_Buy_Close  = 60;
extern int RSI14_Value_Sell_Open = 60;
extern int RSI14_Value_Sell_Close  = 40;
extern int RSI5_Diff_Buy = 1;
extern int RSI5_Diff_Sell = 1;
extern int MaxBuys = 5;
extern int MaxSells = 5;
extern int MaxSumOrders = 0; // if 0, will be ignored, if more than 0, will be used instead both max buys and max sells
extern double    LotsIfNoMM=0.1;
extern bool      UseMM=false;
extern double    MMRiskFactor=0.05;
extern double    MMBalanceExcludeAmt=0;
extern double    MMBalanceShareDivisor=1;
extern int StartHour = 0;
extern int EndHour = 23;
extern bool CloseOncePerMinute = false;

extern int MagicNumber=161;

int action;
datetime prev_time=0;
string Comments = "Shinigami RSI Crossover EA v5, shini1984@gmail.com";

//=================================================================================================================+
int init()
{
return(0);
}
//=================================================================================================================+
int deinit()
{
return(0);
}
//=================================================================================================================+
int start()
{
double Lots;
if(UseMM) Lots=CalculateMMLot();
else Lots=LotsIfNoMM;
int i=0,type=-1,buys=0,sells=0,buysnow=0,sellsnow=0;
double p=Point,open=0,sl=0,tp=0;
int d=Digits;

for(i=0;i<OrdersTotal();i++) {
if(!OrderSelect(i,SELECT_BY_POS,MODE_TRADES)) continue;
if(OrderMagicNumber()!=MagicNumber) continue;
if(OrderSymbol()!=Symbol()) continue;
if(OrderType()==OP_BUY) {
 buys++; if(OrderOpenTime()>=Time[0]) buysnow++; }
if(OrderType()==OP_SELL) {
 sells++; if(OrderOpenTime()>=Time[0]) sellsnow++; }
}

if(buys<MaxOrders(buys,sells,0)&&buysnow==0) {
 if(iRSI(NULL,0,14,PRICE_CLOSE,1)<RSI14_Value_Buy_Open) { //open buy where rsi is lower than some value
  if(iRSI(NULL,0,14,PRICE_CLOSE,1)>iRSI(NULL,0,14,PRICE_CLOSE,2)) { //and RSI is going up
   if(iRSI(NULL,0,5,PRICE_CLOSE,1)>iRSI(NULL,0,14,PRICE_CLOSE,1)+RSI5_Diff_Buy) { //and rsi5 is higher n points
    OrderSend(Symbol(),OP_BUY,Lots,NormalizeDouble(Ask,d),3,0,0,Comments,MagicNumber);
    Sleep(1000); } } } }

if(sells<MaxOrders(buys,sells,1)&&sellsnow==0) {
 if(iRSI(NULL,0,14,PRICE_CLOSE,1)>RSI14_Value_Sell_Open) { //open Sell where rsi is higher than some value
  if(iRSI(NULL,0,14,PRICE_CLOSE,1)<iRSI(NULL,0,14,PRICE_CLOSE,2)) { //and RSI is going down
   if(iRSI(NULL,0,5,PRICE_CLOSE,1)<iRSI(NULL,0,14,PRICE_CLOSE,1)+RSI5_Diff_Sell) { //and rsi5 is lower n points
    OrderSend(Symbol(),OP_SELL,Lots,NormalizeDouble(Bid,d),3,0,0,Comments,MagicNumber);
    Sleep(1000); } } } }

for(i=0;i<OrdersTotal();i++) {
if(!OrderSelect(i,SELECT_BY_POS,MODE_TRADES)) continue;
if(OrderMagicNumber()!=MagicNumber) continue;
if(OrderSymbol()!=Symbol()) continue;
type=OrderType();
if(type==OP_BUY) {
 if(OrderTakeProfit()==0&&OrderStopLoss()==0) {
  open=OrderOpenPrice();
  tp=NormalizeDouble(open+Takeprofit*p,d);
  sl=NormalizeDouble(open-Stoploss*p,d);
  OrderModify(OrderTicket(),OrderOpenPrice(),sl,tp,0);
  open=0; tp=0; sl=0; type=-1; Sleep(1000); } }
if(OrderType()==OP_SELL) {
 if(OrderTakeProfit()==0&&OrderStopLoss()==0) {
  open=OrderOpenPrice();
  tp=NormalizeDouble(open-Takeprofit*p,d);
  sl=NormalizeDouble(open+Stoploss*p,d);
  OrderModify(OrderTicket(),open,sl,tp,0);
  open=0; tp=0; sl=0; type=-1; Sleep(1000); } }
}


if(prev_time!=iTime(Symbol(),PERIOD_M1,0)&&CloseOncePerMinute) {
prev_time=iTime(Symbol(),PERIOD_M1,0);
CloseCheck(); }

if(!CloseOncePerMinute)
CloseCheck();

return(0);
}
//=================================================================================================================+
int MaxOrders(int buys, int sells, int type)
{
if(MaxSumOrders>0) return(MaxSumOrders-buys-sells);
if(MaxSumOrders==0) {
 if(type==0) return(MaxBuys);
 if(type==1) return(MaxSells); }
return(99999);
}
//=================================================================================================================+
double CalculateMMLot()
{
double lot_min =MarketInfo(Symbol(),MODE_MINLOT);
double lot_max =MarketInfo(Symbol(),MODE_MAXLOT);
double lot_step=MarketInfo(Symbol(),MODE_LOTSTEP);
double lot;
if(lot_min<0 || lot_max<=0.0 || lot_step<=0.0) {
 Print("CalculateMMLot: invalid MarketInfo() results [",lot_min,",",lot_max,",",lot_step,"]");
 return(0); }
if(AccountLeverage()<=0) {
 Print("CalculateMMLot: invalid AccountLeverage() [",AccountLeverage(),"]");
 return(0); }
//--- basic formula
lot=NormalizeDouble((AccountBalance()-MMBalanceExcludeAmt)/MMBalanceShareDivisor*MMRiskFactor/AccountLeverage()/10.0,2);
lot=NormalizeDouble(lot/lot_step,0)*lot_step;
if(lot<lot_min) lot=lot_min;
if(lot>lot_max) lot=lot_max;
return(lot);
}
//=================================================================================================================+
void CloseCheck()
{
RefreshRates();
int i=0,d=Digits;
for(i=0;i<OrdersTotal();i++) {
if(!OrderSelect(i,SELECT_BY_POS,MODE_TRADES)) continue;
if(OrderMagicNumber()!=MagicNumber) continue;
if(OrderSymbol()!=Symbol()) continue;
if(OrderType()==OP_BUY) {
 if(iRSI(NULL,0,14,PRICE_CLOSE,1)>RSI14_Value_Buy_Close) { //close buy when rsi is lower than some value
  if(iRSI(NULL,0,14,PRICE_CLOSE,1)<iRSI(NULL,0,14,PRICE_CLOSE,2)) { //and RSI is going down
   if(iRSI(NULL,0,5,PRICE_CLOSE,1)<iRSI(NULL,0,14,PRICE_CLOSE,1)) { //and rsi5 is lower
    OrderClose(OrderTicket(),OrderLots(),NormalizeDouble(Bid,d),3); Sleep(1000); } } } }
if(OrderType()==OP_SELL) {
 if(iRSI(NULL,0,14,PRICE_CLOSE,1)<RSI14_Value_Sell_Close) { //close sell when rsi is lower than some value
  if(iRSI(NULL,0,14,PRICE_CLOSE,1)>iRSI(NULL,0,14,PRICE_CLOSE,2)) { //and RSI is going down
   if(iRSI(NULL,0,5,PRICE_CLOSE,1)>iRSI(NULL,0,14,PRICE_CLOSE,1)) { //and rsi5 is higher
    OrderClose(OrderTicket(),OrderLots(),NormalizeDouble(Ask,d),3); Sleep(1000); } } } }
}
return;
}
//=================================================================================================================+
//=================================================================================================================+
//=================================================================================================================+
//=================================================================================================================+
//=================================================================================================================+
//=================================================================================================================+

